-- name: [CS] Fazbear 64
-- description: Play as everyone's favorite haunted animatronics in Super Mario 64!

local SOUND_KIDSCHEER = audio_sample_load('cheer.ogg')

local TEX_PIZZA_ICON = get_texture_info("pizza-icon")
local E_MODEL_PIZZASLICE = smlua_model_util_get_id("pizzaslice_geo")
local TEX_GIFT_ICON = get_texture_info("gift-icon")
local E_MODEL_GIFT = smlua_model_util_get_id("giftstar_geo")
local TEX_SOUL_ICON = get_texture_info("soul-icon")
local E_MODEL_SOUL = smlua_model_util_get_id("soulstar_geo")

local E_MODEL_FREDDY = smlua_model_util_get_id("freddy_geo")
local E_MODEL_GFREDDY = smlua_model_util_get_id("gfreddy_geo")
local E_MODEL_BONNIE = smlua_model_util_get_id("bonnie_geo")
local E_MODEL_MBONNIE = smlua_model_util_get_id("mbonnie_geo")
local E_MODEL_CHICA = smlua_model_util_get_id("chica_geo")
local E_MODEL_FOXY = smlua_model_util_get_id("foxy_geo")
local E_MODEL_FFOXY = smlua_model_util_get_id("ffoxy_geo")
local E_MODEL_ENDO = smlua_model_util_get_id("endo_geo")
local E_MODEL_PUPPET = smlua_model_util_get_id("puppet_geo")
local E_MODEL_SPRINGTRAP = smlua_model_util_get_id("springtrap_geo")
local E_MODEL_SPRINGBONNIE = smlua_model_util_get_id("springbonnie_geo")

local TEX_LIVES_ICON = get_texture_info("fnaflives")
local TEX_PGLIVES_ICON = get_texture_info("PGlife")

local TEXT_MOD_NAME = "Fazbear 64"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local HEALTH_METER_FNAF= {
    label = {
        left = get_texture_info("fazbearhealthleft"),
        right = get_texture_info("fazbearhealthright"),
    },
    pie = {
        [1] = get_texture_info("fnafpie-1"),
        [2] = get_texture_info("fnafpie-2"),
        [3] = get_texture_info("fnafpie-3"),
        [4] = get_texture_info("fnafpie-4"),
        [5] = get_texture_info("fnafpie-5"),
        [6] = get_texture_info("fnafpie-6"),
        [7] = get_texture_info("fnafpie-7"),
        [8] = get_texture_info("fnafpie-8"),
    }
}
local PALETTE_FREDDY = {
    [PANTS]  = "5E2D01", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "5E2D01", -- hands
    [SHOES]  = "5E2D01", -- feet
    [HAIR]   = "5E2D01", -- main
    [SKIN]   = "764302", -- belly
    [CAP]    = "1A1A1A", -- hat
}

local PALETTE_GFREDDY = {
    [PANTS]  = "B18711", -- nil
    [SHIRT]  = "000000", -- accents
    [GLOVES] = "B18711", -- hands
    [SHOES]  = "B18711", -- feet
    [HAIR]   = "B18711", -- main
    [SKIN]   = "D4A118", -- belly
    [CAP]    = "000000", -- hat
}

local PALETTE_BONNIE = {
    [PANTS]  = "443468", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "443468", -- hands
    [SHOES]  = "443468", -- feet
    [HAIR]   = "443468", -- main
    [SKIN]   = "625C71", -- belly
    [CAP]    = "6E0000", -- hat
}

local PALETTE_MBONNIE = {
    [PANTS]  = "224968", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "224968", -- hands
    [SHOES]  = "224968", -- feet
    [HAIR]   = "224968", -- main
    [SKIN]   = "93ABAB", -- belly
    [CAP]    = "7A1A1B", -- hat
}

local PALETTE_CHICA = {
    [PANTS]  = "937F15", -- nil
    [SHIRT]  = "937F15", -- main
    [GLOVES] = "937F15", -- hands
    [SHOES]  = "9B4709", -- feet
    [HAIR]   = "1A1A1A", -- accents
    [SKIN]   = "AFA139", -- belly
    [CAP]    = "D9517F", -- hat
}

local PALETTE_FOXY = {
    [PANTS]  = "5E2D01", -- pants
    [SHIRT]  = "1A1A1A", -- nil
    [GLOVES] = "7E231D", -- hands
    [SHOES]  = "7E231D", -- feet
    [HAIR]   = "7E231D", -- main
    [SKIN]   = "91483E", -- belly
    [CAP]    = "480505", -- dark main
}

local PALETTE_PUPPET = {
    [PANTS]  = "000000", -- black
    [SHIRT]  = "B3B19F", -- white
    [GLOVES] = "B3B09A", -- mask
    [SHOES]  = "4E0065", -- tears
    [HAIR]   = "000000", -- none
    [SKIN]   = "000000", -- none
    [CAP]    = "AD2E33", -- red
}

local PALETTE_SPRINGTRAP = {
    [PANTS]  = "000000", -- nil
    [SHIRT]  = "262806", -- accents
    [GLOVES] = "3C2E00", -- hands
    [SHOES]  = "000000", -- feet
    [HAIR]   = "3C2E00", -- main
    [SKIN]   = "171600", -- belly
    [CAP]    = "7200A0", -- hat
}

local PALETTE_SPRINGBONNIE = {
    [PANTS]  = "987400", -- nil
    [SHIRT]  = "1A1A1A", -- accents
    [GLOVES] = "987400", -- hands
    [SHOES]  = "987400", -- feet
    [HAIR]   = "987400", -- main
    [SKIN]   = "AF9220", -- belly
    [CAP]    = "7200A0", -- hat
}



local CAPS_FREDDY = {
    normal = smlua_model_util_get_id("freddycap_geo"),
    wing = smlua_model_util_get_id("freddywingcap_geo"),
    metal = smlua_model_util_get_id("freddymetalcap_geo"),
    metalWing = smlua_model_util_get_id("freddywingmetalcap_geo"),
}

local CAPS_BONNIE = {
    normal = smlua_model_util_get_id("bonniecap_geo"),
    wing = smlua_model_util_get_id("bonniewingcap_geo"),
    metal = smlua_model_util_get_id("bonniemetalcap_geo"),
    metalWing = smlua_model_util_get_id("bonniewingmetalcap_geo"),
}

local CAPS_CHICA = {
    normal = smlua_model_util_get_id("cupcake_geo"),
    wing = smlua_model_util_get_id("wingedcupcake_geo"),
    metal = smlua_model_util_get_id("metalcupcake_geo"),
    metalWing = smlua_model_util_get_id("metalwingedcupcake_geo"),
}

local CAPS_FOXY = {
    normal = smlua_model_util_get_id("hook_geo"),
    wing = smlua_model_util_get_id("hookwing_geo"),
    metal = smlua_model_util_get_id("hookmetal_geo"),
    metalWing = smlua_model_util_get_id("hookwingmetal_geo"),
}

local CAPS_PUPPET = {
    normal = smlua_model_util_get_id("puppetmask_geo"),
    wing = smlua_model_util_get_id("puppetwingmask_geo"),
    metal = smlua_model_util_get_id("puppetmetalmask_geo"),
    metalWing = smlua_model_util_get_id("puppetmetalwingmask_geo"),
}

local CAPS_ENDO = {
    normal = smlua_model_util_get_id("endohead_geo"),
    wing = smlua_model_util_get_id("endowinghead_geo"),
    metal = smlua_model_util_get_id("endometalhead_geo"),
    metalWing = smlua_model_util_get_id("endometalwinghead_geo"),
}

local CAPS_SPRINGTRAP = {
    normal = smlua_model_util_get_id("springtraphead_geo"),
    wing = smlua_model_util_get_id("springtrapwinghead_geo"),
    metal = smlua_model_util_get_id("springtrapmetalhead_geo"),
    metalWing = smlua_model_util_get_id("springtrapmetalwinghead_geo"),
}

local VOICETABLE_FREDDY = {
    [CHAR_SOUND_ATTACKED] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DOH] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DROWNING] = 'powerdown.ogg',
    [CHAR_SOUND_DYING] = 'powerdown.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'freddyhah.ogg',
    [CHAR_SOUND_HAHA] = {'freddyhaha.ogg','freddywahoo.ogg'},
    [CHAR_SOUND_HAHA_2] = 'freddyhaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'freddylaughshort.ogg','freddywahoo.ogg'},
    [CHAR_SOUND_HOOHOO] = 'metalrun.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'freddyaww.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'freddylaughshort.ogg',
    [CHAR_SOUND_ON_FIRE] = 'XSCREAM.ogg',
    [CHAR_SOUND_OOOF] = 'freddyaww.ogg',
    [CHAR_SOUND_OOOF2] = 'freddyaww.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'clank1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'clank2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'metalrun.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'freddylaughshort.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = {'freddywahoo.ogg','metaljump2.ogg'},
    [CHAR_SOUND_WAAAOOOW] = 'XSCREAM.ogg',
    [CHAR_SOUND_WAH2] = 'freddyyah.ogg',
    [CHAR_SOUND_WHOA] = 'freddyhah.ogg',
    [CHAR_SOUND_YAHOO] = {'freddywahoo.ogg','metaljump2.ogg'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'clank2.ogg','freddyyah.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'freddyyah.ogg','metalrun.ogg','freddyhah.ogg','clank2.ogg'},
    [CHAR_SOUND_YAWNING] = {'moan1.ogg','moan2.ogg','moan3.ogg','moan4.ogg'},
}

local VOICETABLE_FOXY = {
    [CHAR_SOUND_ATTACKED] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DOH] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DROWNING] = 'powerdown.ogg',
    [CHAR_SOUND_DYING] = 'powerdown.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'foxyhah.ogg',
    [CHAR_SOUND_HAHA] = {'foxyhaha.ogg','foxyyarrg.ogg'},
    [CHAR_SOUND_HAHA_2] = 'foxyhaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'foxylaugh.ogg','foxyhaha.ogg'},
    [CHAR_SOUND_HOOHOO] = 'metalrun.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'foxyarr.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'foxylaugh.ogg',
    [CHAR_SOUND_ON_FIRE] = 'XSCREAM.ogg',
    [CHAR_SOUND_OOOF] = 'foxyarr.ogg',
    [CHAR_SOUND_OOOF2] = 'foxyarr.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'clank1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'clank2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'metalrun.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'foxylaugh.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = {'foxyhaha.ogg','metaljump2.ogg'},
    [CHAR_SOUND_WAAAOOOW] = 'XSCREAM.ogg',
    [CHAR_SOUND_WAH2] = 'foxyhah.ogg',
    [CHAR_SOUND_WHOA] = 'foxyyah.ogg',
    [CHAR_SOUND_YAHOO] = {'foxyhaha.ogg','foxylaugh.ogg','foxyyarrg.ogg','metaljump2.ogg'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'clank2.ogg','foxyyah.ogg','foxyyuh.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'foxyyah.ogg','metalrun.ogg','foxyhah.ogg','clank2.ogg'},
    [CHAR_SOUND_YAWNING] = {'moan1.ogg','moan2.ogg','moan3.ogg','moan4.ogg'},
}

local VOICETABLE_PUPPET = {
[CHAR_SOUND_YAWNING] = 'jackinthebox.ogg'
}

local VOICETABLE_SPRINGTRAP = {
    [CHAR_SOUND_ATTACKED] = {'springtraphurt.ogg','clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DOH] = {'clank1.ogg','clank2.ogg','clank3.ogg','springtraphurt.ogg'},
    [CHAR_SOUND_DROWNING] = 'crush.ogg',
    [CHAR_SOUND_DYING] = 'crush.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'springjump.ogg',
    [CHAR_SOUND_HAHA] = {'springjump2.ogg','springwahoo.ogg'},
    [CHAR_SOUND_HAHA_2] = 'springwahoo.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'ialwayscomeback.ogg','scream3.ogg'},
    [CHAR_SOUND_HOOHOO] = 'metalrun.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'springtraphurt.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = {'springsigh1.ogg','springsigh2.ogg','springsigh3.ogg'},
    [CHAR_SOUND_ON_FIRE] = 'scream3.ogg',
    [CHAR_SOUND_OOOF] = {'springtraphurt.ogg','metalrun.ogg'},
    [CHAR_SOUND_OOOF2] = {'springtraphurt.ogg','clank2.ogg'},
    [CHAR_SOUND_PUNCH_HOO] = 'clank1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'clank2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'metalrun.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'springwahoo.ogg','springsigh2.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = {'springjump.ogg','metaljump2.ogg'},
    [CHAR_SOUND_WAAAOOOW] = 'scream3.ogg',
    [CHAR_SOUND_WAH2] = {'nothing.ogg', 'springjump.ogg','springsigh1.ogg','springsigh2.ogg','springsigh3.ogg'},
    [CHAR_SOUND_WHOA] = {'nothing.ogg', 'springjump.ogg','springsigh1.ogg','springsigh2.ogg','springsigh3.ogg'},
    [CHAR_SOUND_YAHOO] = {'metaljump2.ogg','springsigh1.ogg','springwahoo.ogg'},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'clank2.ogg','springjump.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'metalrun.ogg','clank2.ogg','springjump2.ogg'},
    [CHAR_SOUND_YAWNING] = {'springsigh1.ogg','springsigh2.ogg','springsigh3.ogg'},
}

local VOICETABLE_MUTE = {
    [CHAR_SOUND_ATTACKED] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DOH] = {'clank1.ogg','clank2.ogg','clank3.ogg'},
    [CHAR_SOUND_DROWNING] = 'powerdown.ogg',
    [CHAR_SOUND_DYING] = 'powerdown.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'clank3.ogg',
    [CHAR_SOUND_HAHA] = nil,
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_HERE_WE_GO] = nil,
    [CHAR_SOUND_HOOHOO] = 'metalrun.ogg',
    [CHAR_SOUND_MAMA_MIA] = nil,
    [CHAR_SOUND_OKEY_DOKEY] = nil,
    [CHAR_SOUND_ON_FIRE] = 'XSCREAM.ogg',
    [CHAR_SOUND_OOOF] = 'clank3.ogg',
    [CHAR_SOUND_OOOF2] = 'clank3.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'clank1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'clank2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'metalrun.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = nil,
    [CHAR_SOUND_TWIRL_BOUNCE] = 'metaljump2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'XSCREAM.ogg',
    [CHAR_SOUND_WAH2] = nil,
    [CHAR_SOUND_WHOA] = nil,
    [CHAR_SOUND_YAHOO] = 'metaljump2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'clank2.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = {'metalrun.ogg','clank2.ogg'},
    [CHAR_SOUND_YAWNING] = {'moan1.ogg','moan2.ogg','moan3.ogg','moan4.ogg'},
}

local CSloaded = false
_G.FreddyFNAFCSloaded = false
local function on_character_select_load()
    _G.CT_FREDDY = _G.charSelect.character_add("Freddy Fazbear", "The one and only. Singer in the animatronic band.", "SwagSkeleton95", {r = 94, g = 45, b = 1}, E_MODEL_FREDDY, CT_MARIO, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_BONNIE = _G.charSelect.character_add("Bonnie the Bunny", "The guitarist of the animatronic band.", "SwagSkeleton95", {r = 68, g = 52, b = 104}, E_MODEL_BONNIE, CT_LUIGI, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_CHICA = _G.charSelect.character_add("Chica the Chicken", "Chica's here to encourage you to eat! Also a singer in the band?", "SwagSkeleton95", {r = 147, g = 127, b = 21}, E_MODEL_CHICA, CT_WARIO, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_FOXY = _G.charSelect.character_add("Foxy the Pirate", "Out of order.", "SwagSkeleton95", {r = 126, g = 35, b = 29}, E_MODEL_FOXY, CT_WALUIGI, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_ENDO = _G.charSelect.character_add("Endo-01", {"An animatronic endoskeleton.","(Eye color corresponds to cap color)"}, "SwagSkeleton95", {r = 171, g = 171, b = 171}, E_MODEL_ENDO, CT_WALUIGI, TEX_LIVES_ICON, 1.0, 6)
    _G.CT_PUPPET = _G.charSelect.character_add("The Puppet", "Hangs out in the prize corner. Gives gifts.", "SwagSkeleton95", {r = 179, g = 176, b = 154}, E_MODEL_PUPPET, CT_WALUIGI, TEX_LIVES_ICON, 1.1, 6)
    _G.CT_SPRINGTRAP = _G.charSelect.character_add("Springtrap", "He'll come back.", "SwagSkeleton95", {r = 61, g = 64, b = 11}, E_MODEL_SPRINGTRAP, CT_WALUIGI, TEX_PGLIVES_ICON, 1.0, 6)

    _G.charSelect.character_add_voice(E_MODEL_FREDDY, VOICETABLE_FREDDY)
    _G.charSelect.character_add_voice(E_MODEL_GFREDDY, VOICETABLE_FREDDY)
    _G.charSelect.character_add_voice(E_MODEL_BONNIE, VOICETABLE_MUTE)
    _G.charSelect.character_add_voice(E_MODEL_MBONNIE, VOICETABLE_MUTE)
    _G.charSelect.character_add_voice(E_MODEL_CHICA, VOICETABLE_MUTE)
    _G.charSelect.character_add_voice(E_MODEL_FOXY, VOICETABLE_FOXY)
    _G.charSelect.character_add_voice(E_MODEL_FFOXY, VOICETABLE_FOXY)
    _G.charSelect.character_add_voice(E_MODEL_ENDO, VOICETABLE_MUTE)
    _G.charSelect.character_add_voice(E_MODEL_PUPPET, VOICETABLE_PUPPET)
    _G.charSelect.character_add_voice(E_MODEL_SPRINGTRAP, VOICETABLE_SPRINGTRAP)
    _G.charSelect.character_add_voice(E_MODEL_SPRINGBONNIE, VOICETABLE_MUTE)

    _G.charSelect.character_add_caps(E_MODEL_FREDDY, CAPS_FREDDY)
    _G.charSelect.character_add_caps(E_MODEL_GFREDDY, CAPS_FREDDY)
    _G.charSelect.character_add_caps(E_MODEL_BONNIE, CAPS_BONNIE)
    _G.charSelect.character_add_caps(E_MODEL_MBONNIE, CAPS_BONNIE)
    _G.charSelect.character_add_caps(E_MODEL_CHICA, CAPS_CHICA)
    _G.charSelect.character_add_caps(E_MODEL_FOXY, CAPS_FOXY)
    _G.charSelect.character_add_caps(E_MODEL_FFOXY, CAPS_FOXY)
    _G.charSelect.character_add_caps(E_MODEL_PUPPET, CAPS_PUPPET)
    _G.charSelect.character_add_caps(E_MODEL_ENDO, CAPS_ENDO)
    _G.charSelect.character_add_caps(E_MODEL_SPRINGTRAP, CAPS_SPRINGTRAP)
    _G.charSelect.character_add_caps(E_MODEL_SPRINGBONNIE, CAPS_BONNIE)

    _G.charSelect.character_add_palette_preset(E_MODEL_FREDDY, PALETTE_FREDDY)
    _G.charSelect.character_add_palette_preset(E_MODEL_GFREDDY, PALETTE_GFREDDY)
    _G.charSelect.character_add_palette_preset(E_MODEL_BONNIE, PALETTE_BONNIE)
    _G.charSelect.character_add_palette_preset(E_MODEL_MBONNIE, PALETTE_MBONNIE)
    _G.charSelect.character_add_palette_preset(E_MODEL_CHICA, PALETTE_CHICA)
    _G.charSelect.character_add_palette_preset(E_MODEL_FOXY, PALETTE_FOXY)
    _G.charSelect.character_add_palette_preset(E_MODEL_FFOXY, PALETTE_FOXY)
    _G.charSelect.character_add_palette_preset(E_MODEL_PUPPET, PALETTE_PUPPET)
    _G.charSelect.character_add_palette_preset(E_MODEL_SPRINGTRAP, PALETTE_SPRINGTRAP)
    _G.charSelect.character_add_palette_preset(E_MODEL_SPRINGBONNIE, PALETTE_SPRINGBONNIE)

    _G.charSelect.character_add_celebration_star(E_MODEL_FREDDY, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_GFREDDY, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_BONNIE, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_MBONNIE, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_CHICA, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_FOXY, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_FFOXY, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_PUPPET, E_MODEL_GIFT, TEX_GIFT_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_ENDO, E_MODEL_PIZZASLICE, TEX_PIZZA_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_SPRINGTRAP, E_MODEL_SOUL, TEX_SOUL_ICON)
    _G.charSelect.character_add_celebration_star(E_MODEL_SPRINGBONNIE, E_MODEL_SOUL, TEX_SOUL_ICON)

    _G.charSelect.character_add_health_meter(CT_FREDDY, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_BONNIE, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_CHICA, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_FOXY, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_ENDO, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_PUPPET, HEALTH_METER_FNAF)
    _G.charSelect.character_add_health_meter(CT_SPRINGTRAP, HEALTH_METER_FNAF)

    CSloaded = true
    FreddyFNAFCSloaded = true
    CHARS_FNAF = {
    	[CT_FREDDY] = 1,
    	[CT_BONNIE] = 1,
    	[CT_CHICA] = 1,
    	[CT_FOXY] = 1,
    	[CT_ENDO] = 1,
    	[CT_PUPPET] = 1,
    }
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FREDDY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FOXY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_PUPPET then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SPRINGTRAP then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MUTE then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FREDDY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_FOXY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_PUPPET then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SPRINGTRAP then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MUTE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

-- Play cheers

local function on_interact(m, o, intType)
    if not CSloaded then return end
    if m.playerIndex ~= 0 then return end
    if intType == INTERACT_STAR_OR_KEY and CHARS_FNAF[_G.charSelect.character_get_current_number()] then
        audio_sample_play(SOUND_KIDSCHEER, m.pos, 1.0)
    end
end

hook_event(HOOK_ON_INTERACT, on_interact)

--------------------------------------------
--- Alt Costume code from Paper Partners ---
------------ Thanks, Melzinoff!! -----------
--------- Original code by Wibblus!! -------
--------------------------------------------

local CUR_SKIN_FREDDY = 1
-- table of skins
local SKINTABLE_FREDDY = {
    { model = E_MODEL_FREDDY,  name = "Freddy Fazbear", desc = "The one and only. Singer in the animatronic band.", credit = "SwagSkeleton95", color = {r = 94, g = 45, b = 1}, E_MODEL_FREDDY, CT_MARIO, TEX_LIVES_ICON, offset = 6},
    { model = E_MODEL_GFREDDY,  name = "Golden Freddy", desc = "#######################", credit = "SwagSkeleton95", color = {r = 177, g = 135, b = 17}, E_MODEL_GFREDDY, CT_MARIO, TEX_LIVES_ICON, offset = 6},
}

local function update_character_skin()
    local curFreddySkin = SKINTABLE_FREDDY[CUR_SKIN_FREDDY]
    _G.charSelect.character_edit(CT_FREDDY, curFreddySkin.name, curFreddySkin.desc, curFreddySkin.credit, curFreddySkin.color, curFreddySkin.model, nil, curFreddySkin[6], nil, curFreddySkin.offset)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_FREDDY then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_FREDDY < #SKINTABLE_FREDDY then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_FREDDY = CUR_SKIN_FREDDY + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_FREDDY > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_FREDDY = math.max(CUR_SKIN_FREDDY - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)



local CUR_SKIN_BONNIE = 1
-- table of skins
local SKINTABLE_BONNIE = {
    { model = E_MODEL_BONNIE,  name = "Bonnie the Bunny", desc = "The guitarist of the animatronic band.", credit = "SwagSkeleton95", color = {r = 68, g = 52, b = 104}, E_MODEL_BONNIE, CT_LUIGI, TEX_LIVES_ICON, offset = 6},
    { model = E_MODEL_MBONNIE,  name = "Bonnie (Movie)", desc = "The guitarist of the animatronic band. This version is based on the movie.", credit = "SwagSkeleton95", color = {r = 34, g = 73, b = 104}, E_MODEL_MBONNIE, CT_LUIGI, TEX_LIVES_ICON, offset = 6},
}

local function update_character_skin()
    local curBonnieSkin = SKINTABLE_BONNIE[CUR_SKIN_BONNIE]
    _G.charSelect.character_edit(CT_BONNIE, curBonnieSkin.name, curBonnieSkin.desc, curBonnieSkin.credit, curBonnieSkin.color, curBonnieSkin.model, nil, curBonnieSkin[6], nil, curBonnieSkin.offset)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_BONNIE then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_BONNIE < #SKINTABLE_BONNIE then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_BONNIE = CUR_SKIN_BONNIE + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_BONNIE > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_BONNIE = math.max(CUR_SKIN_BONNIE - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_FOXY = 1
-- table of skins
local SKINTABLE_FOXY = {
    { model = E_MODEL_FOXY,  name = "Foxy the Pirate", desc = "Out of order.", credit = "SwagSkeleton95", color = {r = 126, g = 35, b = 29}, E_MODEL_FOXY, CT_WALUIGI, TEX_LIVES_ICON, offset = 6},
    { model = E_MODEL_FFOXY,  name = "Foxy (Unwithered)", desc = "In order?", credit = "SwagSkeleton95", color = {r = 126, g = 35, b = 29}, E_MODEL_FFOXY, CT_WALUIGI, TEX_LIVES_ICON, offset = 6},
}

local function update_character_skin()
    local curFoxySkin = SKINTABLE_FOXY[CUR_SKIN_FOXY]
    _G.charSelect.character_edit(CT_FOXY, curFoxySkin.name, curFoxySkin.desc, curFoxySkin.credit, curFoxySkin.color, curFoxySkin.model, nil, curFoxySkin[6], nil, curFoxySkin.offset)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_FOXY then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_FOXY < #SKINTABLE_FOXY then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_FOXY = CUR_SKIN_FOXY + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_FOXY > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_FOXY = math.max(CUR_SKIN_FOXY - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)

local CUR_SKIN_SPRINGTRAP = 1
-- table of skins
local SKINTABLE_SPRINGTRAP = {
    { model = E_MODEL_SPRINGTRAP,  name = "Springtrap", desc = {"He always does."," "," ","We have a place for him. "}, credit = "SwagSkeleton95", color = {r = 61, g = 64, b = 11}, E_MODEL_SPRINGTRAP, CT_WALUIGI, TEX_PGLIVES_ICON, offset = 6},
    { model = E_MODEL_SPRINGBONNIE,  name = "Springbonnie", desc = "Fredbear's original partner! What a friendly face.", credit = "SwagSkeleton95", color = {r = 152, g = 116, b = 0}, E_MODEL_SPRINGBONNIE, CT_WALUIGI, TEX_LIVES_ICON, offset = 6},
}

local function update_character_skin()
    local curSpringtrapSkin = SKINTABLE_SPRINGTRAP[CUR_SKIN_SPRINGTRAP]
    _G.charSelect.character_edit(CT_SPRINGTRAP, curSpringtrapSkin.name, curSpringtrapSkin.desc, curSpringtrapSkin.credit, curSpringtrapSkin.color, curSpringtrapSkin.model, nil, curSpringtrapSkin[6], nil, curSpringtrapSkin.offset)
end
local inputLockTimer = 0
_G.charSelect.hook_render_in_menu(function()
    if _G.charSelect.character_get_current_number() == CT_SPRINGTRAP then
        ---@type Controller
        local c = _G.charSelect.controller

        djui_hud_set_font(FONT_NORMAL)
        djui_hud_set_resolution(RESOLUTION_N64)
        local scale = 0.5
        local x1 = djui_hud_get_screen_width() * .048
        local x2 = x1 + math.max(85, djui_hud_get_screen_width() * .196)

        -- >
        if CUR_SKIN_SPRINGTRAP < #SKINTABLE_SPRINGTRAP then
            -- the < > icons move with inputLockTimer for very cool reactive ui
            djui_hud_print_text(">", x2 + inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                CUR_SKIN_SPRINGTRAP = CUR_SKIN_SPRINGTRAP + 1
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- <
        if CUR_SKIN_SPRINGTRAP > 1 then
            djui_hud_print_text("<", x1 - inputLockTimer, 90, scale)

            if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                CUR_SKIN_SPRINGTRAP = math.max(CUR_SKIN_SPRINGTRAP - 1, 1)
                update_character_skin()
                inputLockTimer = 5
            end
        end
        -- use an input lock to prevent cycling too fast
        inputLockTimer = math.max(0, inputLockTimer - 1)
    end
end)